part of tecfy_core_client_package;

class LoginController extends BaseController {
  late GlobalKey formKey;
  late TextEditingController usernameController;
  late TextEditingController passwordController;
  late AccountService service;

  String usernameValidator(String? v) =>
      v == null || v.isEmpty ? 'Please Enter your Email or Username' : '';
  String passwordValidator(String? v) =>
      v== null || v.isEmpty ? 'Please Enter your Password' : '';

  LoginController(State<StatefulWidget> state) : super(state) {
    formKey = GlobalKey<FormState>();
    usernameController = TextEditingController();
    passwordController = TextEditingController();
    service = AccountService();
  }

  Future onLogin() async {
    // var status = formKey.currentState.validate();
    // if(!status)return;
    // setLoading();
    // await Future.delayed(Duration(seconds: 2));
    print(
        '------ start Login UserName:${usernameController.text.trim()}  Password:${passwordController.text.trim()}');
    var result = await service.login(
        usernameController.text.trim(), passwordController.text.trim());
    print('================== Login result============');
    print(result);
    print(result.success);
    print(result.message);
    if (result.success) {
      await AccountService.init(context);
      // showMessage("Success",type:MessageType.info);
    } else {
      //  setResume();
      showMessage(result.message ?? "Error", type: MessageType.error);
    }
    // setResume();
    // showMessage('result.message',type:MessageType.error);
  }

  contactUs() async {
    Widget getField(label, value) {
      return Row(crossAxisAlignment: CrossAxisAlignment.start, children: [
        Text('${AppLocale.translate(context, label)}:',
            style: TextStyle(fontWeight: FontWeight.bold)),
        SizedBox(width: 10),
        Expanded(child: Text(value, maxLines: 5)),
      ]);
    }

    await AppNavigator.showAppDialog(
      context,
      (c) => Material(
        type: MaterialType.transparency,
        child: Center(
          child: Container(
            width: 300,
            height: 300,
            child: Card(
                margin: EdgeInsets.all(10),
                child: Padding(
                    padding: EdgeInsets.all(10),
                    child: Column(children: [
                      getField('Website', 'https://tecfy.co'),
                      getField('Email', 'info@tecfy.co'),
                      getField('Address',
                          'Office 1 Al-Nile and Damanhor Tower, Al-Arab, Port Said, Egypt'),
                      Expanded(child: Container()),
                      TextButton(
                          child: Text(AppLocale.translate(context, 'Close'),
                              style: TextStyle(color: ThemeService.subColor)),
                          onPressed: () => Navigator.of(context).pop())
                    ]))),
          ),
        ),
      ),
    );
    //await service.loginAnonymously();
    // AppNavigator.navigateTo(context, () => HomePage(),replaceAll: true, animationType: AnimationTypes.opacity);
  }
}
