part of tecfy_core_client_package;

class DateProperty extends StatefulWidget {
  final String? label;
  final bool isRequired;
  final dynamic initalValue;
  final void Function(DateTime?)? onChanged;
  DateProperty(
      {this.label, this.isRequired = false, this.initalValue, this.onChanged});
  @override
  _DatePropertyState createState() => _DatePropertyState();
}

class _DatePropertyState extends State<DateProperty> {
  DateTime? selectedValue;

  @override
  void initState() {
    print('initalValue : ${widget.initalValue}');
    if (widget.initalValue != null) {
      if (widget.initalValue is String) {
        print('trying to parse');
        selectedValue = BaseModel.parseUTC(widget.initalValue);
      } else if (widget.initalValue is DateTime) {
        selectedValue = widget.initalValue;
      }
    }
    super.initState();
  }

  void onPressed() async {
    var value = await showDatePicker(
        builder: (context, child) {
          return Theme(
            data: Theme.of(context).copyWith(
              colorScheme: ColorScheme.light(
                primary: ThemeService.mainColor,
                onPrimary: Colors.white,
                onSurface: Colors.black,
              ),
              textButtonTheme: TextButtonThemeData(
                style: TextButton.styleFrom(
                  primary: Colors.black,
                ),
              ),
            ),
            child: child ?? Container(),
          );
        },
        context: context,
        firstDate: DateTime(1900),
        initialDate: selectedValue ?? DateTime.now().toUtc(),
        lastDate: DateTime(2500));
    setState(() {
      selectedValue = value?.toUtc();
    });
    widget.onChanged?.call(selectedValue);
  }

  onPrint() {
    if (selectedValue == null && widget.initalValue != null) {
      if (widget.initalValue is String) {
        print('trying to parse');
        selectedValue = BaseModel.parseUTC(widget.initalValue);
      } else if (widget.initalValue is DateTime) {
        selectedValue = widget.initalValue;
      }
    }
  }

  @override
  Widget build(BuildContext context) {
    onPrint();
    return MaterialButton(
        padding: EdgeInsets.all(0),
        onPressed: onPressed,
        child: widget.label == null
            ? Text(selectedValue != null
                ? intl.DateFormat("dd/MM/yyyy").format(selectedValue!.toLocal())
                : '[Click To Select]')
            : Column(
                crossAxisAlignment: CrossAxisAlignment.start,
                children: <Widget>[
                  SizedBox(height: 10),
                  Text(
                    '${widget.label ?? ''}${(widget.isRequired) ? '*' : ''}',
                    style: ThemeService.labelStyle,
                  ),
                  Text(selectedValue != null
                      ? intl.DateFormat("dd/MM/yyyy")
                          .format(selectedValue!.toLocal())
                      : '[Click To Select]'),
                  SizedBox(height: 10),
                  Container(height: 1, color: ThemeService.textSubColor)
                ],
              ));
  }
}
