part of tecfy_core_client_package;

class ManyToManyProperty extends StatefulWidget {
  final List<dynamic>? selectedValues;
  final Entity entity;
  final String? label;
  final bool isRequired;
  final void Function(List<dynamic>)? onChanged;
  ManyToManyProperty(
      {this.selectedValues,
      this.onChanged,
      required this.entity,
      this.isRequired = false,
      this.label});
  @override
  _ManyToManyPropertyState createState() => _ManyToManyPropertyState();
}

class _ManyToManyPropertyState extends State<ManyToManyProperty> {
  List<dynamic>? data;
  List<dynamic>? initValue;
  List<dynamic> selectedValues = [];
  String displayFieldName = 'display';
  @override
  void initState() {
    var displayFileds = widget.entity.properties.where((e) => e.isDisplayField);
    if (displayFileds.length > 1) {
      var d =
          displayFileds.where((e) => e.language == LocalConfigService.language);
      if (d.length > 0) displayFileds = d;
    }
    if (displayFileds.length > 0) displayFieldName = displayFileds.first.dbName;
    EntityService.getData(widget.entity).then((result) {
      if (result.success) {
        initValue = null;
        data = result.data;
        select();
        setState(() {});
      } else
        result.showMessage(context);
    });
    super.initState();
  }

  select() {
    if (initValue == widget.selectedValues) return;
    initValue = widget.selectedValues;
    if (data == null ||
        data!.length == 0 ||
        widget.selectedValues == null ||
        widget.selectedValues!.length == 0)
      selectedValues = [];
    else
      selectedValues =
          data!.where((i) => widget.selectedValues!.contains(i['id'])).toList();
  }

  @override
  Widget build(BuildContext context) {
    select();
    return TextButton(
      //padding: EdgeInsets.all(0),
      child: Column(
        crossAxisAlignment: CrossAxisAlignment.start,
        children: <Widget>[
          SizedBox(height: 25.0),
          selectedValues.length == 0
              ? Padding(
                  padding: EdgeInsets.only(bottom: 10.0),
                  child: Text('${widget.label}${widget.isRequired ? '*' : ''}',
                      style: TextStyle(
                          fontSize: 20, fontWeight: FontWeight.normal)))
              : Wrap(
                  spacing: 3.0,
                  children: selectedValues
                      .map((d) => Chip(label: Text(d[displayFieldName])))
                      .toList()),
          //style:TextStyle(fontSize: 18.0, color: Colors.black)),
          SizedBox(height: 5.0),
          Container(
            // margin: EdgeInsetsDirectional.only(start: 1.0, end: 1.0),
            height: 1.0,
            color: Colors.black,
          ),
          SizedBox(height: 20.0),
        ],
      ),
      onPressed: () {
        openMultiSelectDialog();
      },
    );
  }

  openMultiSelectDialog() {
    AppNavigator.showAppDialog(
        context,
        (_) => MultiSelectDialog(
              data ?? [],
              selectedValues,
              (d) {
                if (d != null) {
                  var dd = d.map((i) => i['id']).toList();
                  widget.onChanged?.call(dd);
                }
                setState(() {});
              },
              labelPropertyName: displayFieldName,
            ),
        animationType: AnimationTypes.slideUp);
  }
}
