part of tecfy_core_client_package;

class PhotoProperty extends StatefulWidget {
  final Map<String, dynamic>? fileData;
  final String? label;
  final bool isRequired;
  final String? fileId;
  final void Function(Map<String, dynamic>)? onChanged;
  PhotoProperty(
      {this.fileData,
      this.label,
      this.onChanged,
      this.fileId,
      this.isRequired = false}); //: assert(fileId != null );
  @override
  _PhotoPropertyState createState() => _PhotoPropertyState();
}

class _PhotoPropertyState extends State<PhotoProperty> {
  dynamic photo;

  onChosePhoto() async {
    photo = await ImageService().getImage();
    if (photo != null) {
      AppNavigator.showLoading(context);
      //print('File Length : ${photo.data.length}');
      // show loading and upload the photo
      var result = await TecfyBasicApp.apiService.httpPostFile('Attachment',
          (await photo!.readAsBytes()), path.basename(photo!.name));
      Navigator.pop(context);
      if (result.success) {
        widget.onChanged?.call({'id': result.data});
        AppNavigator.showMessage(context, 'تم رفع الصورة بنجاح');
      } else {
        print('XXXXXXXXXXXXXXXXXXXX Image Upload Error: ${result.message}');
        AppNavigator.showMessage(context, 'خطأ اثناء رفع الصوره',
            message: result.message, type: MessageType.error);
        photo = null;
      }
      //print(result.toString());
    }
    setState(() {});
  }

  @override
  Widget build(BuildContext context) {
    return Padding(
        padding: EdgeInsets.all(10),
        child: Row(
          mainAxisAlignment: MainAxisAlignment.center,
          children: <Widget>[
            GestureDetector(
              onTap: onChosePhoto,
              child: photo != null
                  ? CircleAvatar(
                      backgroundImage: Image.file(File(photo!.path)).image,
                      radius: 55.0,
                    )
                  : widget.fileData != null || widget.fileId != null
                      ? CircleAvatar(
                          backgroundImage: ImageService.imageProvider(
                              widget.fileData != null &&
                                      widget.fileData!['id'] != null
                                  ? widget.fileData!['id']
                                  : widget.fileId),
                          radius: 55.0)
                      :
                      // Image.asset('assets/images/profile_pic.png',height: 110.0)
                      Column(
                          children: <Widget>[
                            Icon(Icons.photo_size_select_actual),
                            Text(
                                '${widget.label ?? 'Select Image'}${widget.isRequired ? '*' : ''}')
                          ],
                        ),
            ),
          ],
        ));
  }
}
