part of tecfy_core_client_package;

class AppIconButton extends StatefulWidget {
  final Widget icon;
  final String? tooltip;
  final Future Function()? onPressed;
  const AppIconButton(
      {Key? key, required this.icon, required this.onPressed, this.tooltip})
      : super(key: key);

  @override
  _AppIconButtonState createState() => _AppIconButtonState();
}

class _AppIconButtonState extends State<AppIconButton> {
  bool isLoading = false;
  @override
  Widget build(BuildContext context) {
    return IconButton(
      icon: isLoading ? CircularProgressIndicator() : widget.icon,
      onPressed: () async {
        if (isLoading || widget.onPressed == null) return;
        setState(() => isLoading = true);
        await widget.onPressed!();
        setState(() => isLoading = false);
      },
      tooltip: widget.tooltip,
    );
  }
}
