part of tecfy_core_client_package;

class SettingIcon extends StatelessWidget {
  final Color color;
  SettingIcon({required this.color});
  @override
  Widget build(BuildContext context) {
    return StreamBuilder<Connection?>(
        stream: ConnectionService.activeConnectionStream,
        initialData: ConnectionService.activeConnection,
        builder: (context, snap) => IconButton(
              tooltip: AppLocale.translate(context, 'Settings'),
              icon: Stack(
                children: <Widget>[
                  Icon(Icons.settings, color: color),
                  CircleAvatar(
                    radius: 5, backgroundColor: snap.data?.color ?? Colors.red,
                    foregroundColor: Colors.white,
                    //child:
                    // Text(snap.data?.name ?? '-', style: TextStyle(fontSize: 8),)
                  )
                ],
              ),
              onPressed: () =>
                  AppNavigator.navigateToNamed(context, '/setting'),
            ));
  }
}
